#!/usr/bin/env python
"""
U2FsdGVkX19cV2plTMSqbpdFaJuEChbUka1NX+X4qeSMMFuTquH1Wd+vL6e2Hf4H
CAvb+R3+MDOCjdOyhgS3DNleCDqZRRJorq7lehTQzbA/pY9TMQBMyUnm63wUOjd/
EKVAggOM+jODpiFn0+FN4le8LUoOErVSZSR7L4gka/7L69wT82r90gq12H1mFNns
judHXORdh3Iud6J8UQHqSZUSFRfnd1IetIIySIIVxxCPE0DY2CS7Y/TjmEiHduzm
l4TiHrn9MlQOJY21PIjswrB9EIS/fsQsNV09BIBh6cJTu2jPULRjOpVGw+liyvkJ
I6HynL0O7XEVC61l2wiQJA==
"""

from base_msg import PSBP, SOURCE_ADDRESS
from utils import fmt_repr

PSBP_MSG_STATUS = 0x00


class MsgStatus(PSBP):
    """
    Status Msg is the same as the base message
    """

    def __init__(self, psbp=None, **kwargs):
        if psbp:
            super(MsgStatus,
                  self).__init__(psbp.receiver_address, psbp.source_address, psbp.data_length, psbp.flag,
                                 psbp.command, psbp.payload, psbp.crc)
        else:
            super(MsgStatus, self).__init__()
            self.receiver_address = kwargs.pop('receiver_address')
            self.source_address = kwargs.pop('source_address', SOURCE_ADDRESS)
            self.flag = kwargs.pop('flag')
            self.command = PSBP_MSG_STATUS

    def __repr__(self):
        return fmt_repr(self)


msg_classes = {
    0x00: MsgStatus,
}

if __name__ == '__main__':
    print('Simple Test for a Status Message')
    msg = MsgStatus(receiver_address=0x40, flag=(1 << 4))
    packed_msg = msg.pack()
    print(':'.join(hex(ord(x))[2:] for x in packed_msg))
    raw_bin = msg.to_binary()
    print(':'.join(hex(ord(x))[2:] for x in raw_bin))
